Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1686)
+++ palm/trunk/SOURCE/Makefile	(revision 1691)
@@ -13,5 +13,5 @@
 # PALM. If not, see <http://www.gnu.org/licenses/>.
 #
-# Copyright 1997-2014  Leibniz Universitaet Hannover
+# Copyright 1997-2015  Leibniz Universitaet Hannover
 #--------------------------------------------------------------------------------#
 #
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-# 
+# Replaced prandtl_fluxes with surface_layer_fluxes. Added radiation_model to 
+# prognostic_equations
 # 
 # Former revisions:
@@ -239,5 +240,5 @@
 	mod_particle_attributes.f90 netcdf.f90 nudging.f90 package_parin.f90 \
 	palm.f90 parin.f90 plant_canopy_model.f90 poisfft.f90 poismg.f90 \
-	poismg_fast.f90 prandtl_fluxes.f90 pres.f90 print_1d.f90 production_e.f90 \
+	poismg_fast.f90 pres.f90 print_1d.f90 production_e.f90 \
 	prognostic_equations.f90 progress_bar.f90 radiation_model.f90 \
 	random_function.f90 random_gauss.f90 random_generator_parallel.f90 \
@@ -245,5 +246,5 @@
 	set_slicer_attributes_dvrp.f90 singleton.f90 sor.f90 \
 	subsidence.f90 sum_up_3d_data.f90 \
-	surface_coupler.f90 swap_timelevel.f90 temperton_fft.f90 \
+	surface_coupler.f90 surface_layer_fluxes.f90 swap_timelevel.f90 temperton_fft.f90 \
 	time_integration.f90 time_to_string.f90 timestep.f90 \
 	timestep_scheme_steering.f90 transpose.f90 tridia_solver.f90 \
@@ -356,5 +357,5 @@
 init_3d_model.o: modules.o cpulog.o mod_kinds.o random_function.o advec_ws.o\
 	land_surface_model.o ls_forcing.o lpm_init.o plant_canopy_model.o\
-        radiation_model.o random_generator_parallel.o
+	radiation_model.o random_generator_parallel.o surface_layer_fluxes.o
 init_advec.o: modules.o mod_kinds.o
 init_cloud_physics.o: modules.o mod_kinds.o
@@ -421,5 +422,4 @@
 poismg.o: modules.o cpulog.o mod_kinds.o
 poismg_fast.o: modules.o cpulog.o mod_kinds.o
-prandtl_fluxes.o: modules.o mod_kinds.o
 pres.o: modules.o cpulog.o mod_kinds.o poisfft.o poismg_fast.o
 print_1d.o: modules.o cpulog.o mod_kinds.o
@@ -430,5 +430,6 @@
 	cpulog.o diffusion_e.o diffusion_s.o diffusion_u.o diffusion_v.o diffusion_w.o \
 	eqn_state_seawater.o impact_of_latent_heat.o mod_kinds.o microphysics.o \
-	nudging.o plant_canopy_model.o production_e.o subsidence.o user_actions.o
+	nudging.o plant_canopy_model.o production_e.o radiation_model.o \
+	subsidence.o user_actions.o
 progress_bar.o: modules.o mod_kinds.o
 radiation_model.o : modules.o mod_particle_attributes.o
@@ -446,6 +447,7 @@
 subsidence.o: modules.o mod_kinds.o
 sum_up_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model.o\
-                  radiation_model.o
+                  radiation_model.o 
 surface_coupler.o: modules.o cpulog.o mod_kinds.o
+surface_layer_fluxes.o: modules.o mod_kinds.o land_surface_model.o
 swap_timelevel.o: modules.o cpulog.o mod_kinds.o land_surface_model.o
 temperton_fft.o: modules.o mod_kinds.o
@@ -454,5 +456,5 @@
 	ls_forcing.o mod_kinds.o nudging.o production_e.o \
 	prognostic_equations.o progress_bar.o radiation_model.o \
-	user_actions.o
+	 user_actions.o surface_layer_fluxes.o
 time_to_string.o: mod_kinds.o
 timestep.o: modules.o cpulog.o mod_kinds.o
@@ -492,3 +494,3 @@
                    radiation_model.o random_function.o\
                    random_generator_parallel.o
-write_var_list.o: modules.o mod_kinds.o plant_canopy_model.o
+write_var_list.o: modules.o mod_kinds.o plant_canopy_model.o 
Index: palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_bc.f90	(revision 1686)
+++ palm/trunk/SOURCE/advec_s_bc.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Formatting corrections
 ! 
 ! Former revisions:
@@ -464,5 +464,5 @@
                 IF ( sw(k,i+1) == 1.0_wp )  THEN
                    snenn = sk_p(k,j,i) - sk_p(k,j,i+2)
-                   IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                    sterm = ( sk_p(k,j,i+1) - sk_p(k,j,i+2) ) / snenn
                    sterm = MIN( sterm, 0.9999_wp )
@@ -760,5 +760,5 @@
                 IF ( sw(k,j+1) == 1.0_wp )  THEN
                    snenn = sk_p(k,j,i) - sk_p(k,j+2,i)
-                   IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                    sterm = ( sk_p(k,j+1,i) - sk_p(k,j+2,i) ) / snenn
                    sterm = MIN( sterm, 0.9999_wp )
@@ -1209,5 +1209,5 @@
                 IF ( sw(k+1,j) == 1.0_wp )  THEN
                    snenn = sk_p(k,j,i) - sk_p(k+2,j,i)
-                   IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
+                   IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                    sterm = ( sk_p(k+1,j,i) - sk_p(k+2,j,i) ) / snenn
                    sterm = MIN( sterm, 0.9999_wp )
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 1686)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of Obukhov length and radiative heating rates for RRTMG. 
 ! 
 ! Former revisions:
@@ -96,6 +96,9 @@
     USE radiation_model_mod,                                                   &
         ONLY:  rad_net, rad_net_av, rad_lw_in, rad_lw_in_av, rad_lw_out,       &
-               rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out,             &
-               rad_sw_out_av
+               rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,        &
+               rad_lw_hr_av, rad_sw_in, rad_sw_in_av, rad_sw_out,              &
+               rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,        &
+               rad_sw_hr_av
+
 
     IMPLICIT NONE
@@ -213,4 +216,11 @@
              ENDDO
 
+         CASE ( 'ol*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   ol_av(j,i) = ol_av(j,i) / REAL( average_count_3d, KIND=wp )
+                ENDDO
+             ENDDO
+
           CASE ( 'p' )
              DO  i = nxlg, nxrg
@@ -383,4 +393,22 @@
              ENDDO
 
+          CASE ( 'rad_lw_cs_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_cs_hr_av(k,j,i) = rad_lw_cs_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_lw_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_lw_hr_av(k,j,i) = rad_lw_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
           CASE ( 'rad_sw_in' )
              DO  i = nxlg, nxrg
@@ -397,4 +425,22 @@
                    DO  k = nzb, nzt+1
                       rad_sw_out_av(k,j,i) = rad_sw_out_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_cs_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_cs_hr_av(k,j,i) = rad_sw_cs_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'rad_sw_hr' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      rad_sw_hr_av(k,j,i) = rad_sw_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1686)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of Obukhov length (ol) and radiative heating rates for RRTMG. 
+! Added checks for use of radiation / lsm with topography.
 ! 
 ! Former revisions:
@@ -307,4 +308,5 @@
     USE transpose_indices
 
+
     IMPLICIT NONE
 
@@ -650,6 +652,6 @@
           WRITE( action, '(A)' )  'cloud_droplets = .TRUE.'
        ENDIF
-       IF ( .NOT. prandtl_layer )  THEN
-          WRITE( action, '(A)' )  'prandtl_layer = .FALSE.'
+       IF ( .NOT. constant_flux_layer )  THEN
+          WRITE( action, '(A)' )  'constant_flux_layer = .FALSE.'
        ENDIF
        IF ( action /= ' ' )  THEN
@@ -1007,8 +1009,14 @@
        ENDIF
 
-       IF ( .NOT. prandtl_layer )  THEN
+       IF ( .NOT. constant_flux_layer )  THEN
           message_string = 'lsm requires '//                                   &
-                           'prandtl_layer = .T.'
+                           'constant_flux_layer = .T.'
           CALL message( 'check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( topography /= 'flat' )  THEN
+          message_string = 'lsm cannot be used ' //  & 
+                           'in combination with  topography /= "flat"'
+          CALL message( 'check_parameters', 'PA0415', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -1196,7 +1204,10 @@
           CALL message( 'check_parameters', 'PA0411', 1, 2, 0, 6, 0 )
        ENDIF
-
-    ENDIF
-
+       IF ( topography /= 'flat' )  THEN
+          message_string = 'radiation scheme cannot be used ' //  & 
+                           'in combination with  topography /= "flat"'
+          CALL message( 'check_parameters', 'PA0414', 1, 2, 0, 6, 0 )
+       ENDIF
+    ENDIF
 
     IF ( .NOT. ( loop_optimization == 'cache'  .OR.                            &
@@ -1729,5 +1740,5 @@
 !-- In case of using a prandtl-layer, calculated (or prescribed) surface
 !-- fluxes have to be used in the diffusion-terms
-    IF ( prandtl_layer )  use_surface_fluxes = .TRUE.
+    IF ( constant_flux_layer )  use_surface_fluxes = .TRUE.
 
 !
@@ -1796,5 +1807,5 @@
     ELSEIF ( bc_e_b == '(u*)**2+neumann' )  THEN
        ibc_e_b = 2
-       IF ( .NOT. prandtl_layer )  THEN
+       IF ( .NOT. constant_flux_layer )  THEN
           bc_e_b = 'neumann'
           ibc_e_b = 1
@@ -2003,5 +2014,5 @@
        IF ( surface_waterflux == 9999999.9_wp  )  THEN
           constant_waterflux = .FALSE.
-          IF ( large_scale_forcing )  THEN
+          IF ( large_scale_forcing .OR. land_surface )  THEN
              IF ( ibc_q_b == 0 )  THEN
                 constant_waterflux = .FALSE.
@@ -2045,7 +2056,8 @@
     ELSEIF ( bc_uv_b == 'neumann' )  THEN
        ibc_uv_b = 1
-       IF ( prandtl_layer )  THEN
+       IF ( constant_flux_layer )  THEN
           message_string = 'boundary condition: bc_uv_b = "' // &
-               TRIM( bc_uv_b ) // '" is not allowed with prandtl_layer = .TRUE.'
+               TRIM( bc_uv_b ) // '" is not allowed with constant_flux_layer'  &
+               // ' = .TRUE.'
           CALL message( 'check_parameters', 'PA0075', 1, 2, 0, 6, 0 )
        ENDIF
@@ -2356,5 +2368,5 @@
              dopr_unit(i)  = 'm2/s2'
              hom(:,2,12,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( prandtl_layer )  hom(nzb,2,12,:) = zu(1)
+             IF ( constant_flux_layer )  hom(nzb,2,12,:) = zu(1)
 
           CASE ( 'w*u*' )
@@ -2367,5 +2379,5 @@
              dopr_unit(i)  = 'm2/s2'
              hom(:,2,14,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( prandtl_layer )  hom(nzb,2,14,:) = zu(1)
+             IF ( constant_flux_layer )  hom(nzb,2,14,:) = zu(1)
 
           CASE ( 'w*v*' )
@@ -2393,5 +2405,5 @@
              dopr_unit(i)  = 'm2/s2'
              hom(:,2,19,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( prandtl_layer )  hom(nzb,2,19,:) = zu(1)
+             IF ( constant_flux_layer )  hom(nzb,2,19,:) = zu(1)
 
           CASE ( 'wv' )
@@ -2399,5 +2411,5 @@
              dopr_unit(i)  = 'm2/s2'
              hom(:,2,20,:) = SPREAD( zw, 2, statistic_regions+1 )
-             IF ( prandtl_layer )  hom(nzb,2,20,:) = zu(1)
+             IF ( constant_flux_layer )  hom(nzb,2,20,:) = zu(1)
 
           CASE ( 'w*pt*BC' )
@@ -3153,4 +3165,56 @@
              ENDIF
 
+          CASE ( 'rad_lw_cs_hr' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme /= 'rrtmg' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme /= "rrtmg"'
+                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 106
+                dopr_unit(i)  = 'K/h'
+                hom(:,2,106,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_lw_hr' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme /= 'rrtmg' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme /= "rrtmg"'
+                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 107
+                dopr_unit(i)  = 'K/h'
+                hom(:,2,107,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_sw_cs_hr' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme /= 'rrtmg' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme /= "rrtmg"'
+                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 108
+                dopr_unit(i)  = 'K/h'
+                hom(:,2,108,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
+          CASE ( 'rad_sw_hr' )
+             IF ( (.NOT. radiation) .OR. radiation_scheme /= 'rrtmg' )  THEN
+                message_string = 'data_output_pr = ' //                        &
+                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
+                                 'lable for radiation = .FALSE. or ' //        &
+                                 'radiation_scheme /= "rrtmg"'
+                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
+             ELSE
+                dopr_index(i) = 109
+                dopr_unit(i)  = 'K/h'
+                hom(:,2,109,:)  = SPREAD( zu, 2, statistic_regions+1 )
+             ENDIF
+
           CASE DEFAULT
 
@@ -3351,8 +3415,8 @@
              unit = 'kg/kg'
 
-
-          CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out' )
+          CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_lw_cs_hr', 'rad_lw_hr',       &
+                 'rad_sw_in', 'rad_sw_out', 'rad_sw_cs_hr', 'rad_sw_hr' )
              IF ( .NOT. radiation .OR. radiation_scheme /= 'rrtmg' )  THEN
-                message_string = '"output of "' // TRIM( var ) // '" requi' //  &
+                message_string = '"output of "' // TRIM( var ) // '" requi' // &
                                  'res radiation = .TRUE. and ' //              &
                                  'radiation_scheme = "rrtmg"'
@@ -3395,5 +3459,5 @@
 
           CASE ( 'c_liq*', 'c_soil*', 'c_veg*', 'ghf_eb*', 'lai*', 'lwp*',     &
-                 'm_liq_eb*', 'pra*', 'prr*', 'qsws*', 'qsws_eb*',             &
+                 'm_liq_eb*', 'ol*', 'pra*', 'prr*', 'qsws*', 'qsws_eb*',      &
                  'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*', 'rad_net*',  &
                  'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*', 'rrtm_asdir*',   &
@@ -3514,5 +3578,7 @@
              IF ( TRIM( var ) == 'ghf_eb*')  unit = 'W/m2'
              IF ( TRIM( var ) == 'lai*'   )  unit = 'none'
-             IF ( TRIM( var ) == 'lwp*'   )  unit = 'kg/kg*m'
+             IF ( TRIM( var ) == 'lwp*'   )  unit = 'kg/m2'
+             IF ( TRIM( var ) == 'm_liq_eb*'     )  unit = 'm'
+             IF ( TRIM( var ) == 'ol*'   )   unit = 'm'
              IF ( TRIM( var ) == 'pra*'   )  unit = 'mm'
              IF ( TRIM( var ) == 'prr*'   )  unit = 'mm/s'
@@ -3788,7 +3854,7 @@
           constant_diffusion = .TRUE.
 
-          IF ( prandtl_layer )  THEN
-             message_string = 'prandtl_layer is not allowed with fixed ' //    &
-                              'value of km'
+          IF ( constant_flux_layer )  THEN
+             message_string = 'constant_flux_layer is not allowed with fixed ' &
+                              // 'value of km'
              CALL message( 'check_parameters', 'PA0123', 1, 2, 0, 6, 0 )
           ENDIF
@@ -3816,8 +3882,8 @@
 
 !
-!-- Check value range for rif
-    IF ( rif_min >= rif_max )  THEN
-       WRITE( message_string, * )  'rif_min = ', rif_min, ' must be less ',    &
-                                   'than rif_max = ', rif_max
+!-- Check value range for zeta = z/L
+    IF ( zeta_min >= zeta_max )  THEN
+       WRITE( message_string, * )  'zeta_min = ', zeta_min, ' must be less ',  &
+                                   'than zeta_max = ', zeta_max
        CALL message( 'check_parameters', 'PA0125', 1, 2, 0, 6, 0 )
     ENDIF
@@ -4235,4 +4301,14 @@
 
 !
+!-- Check for valid setting of most_method
+    IF ( TRIM( most_method ) /= 'circular'  .AND.                              &
+         TRIM( most_method ) /= 'newton'  .AND.                                &
+         TRIM( most_method ) /= 'lookup' )  THEN
+       message_string = 'most_method = "' // TRIM( most_method ) //      &
+                        '" is unknown'
+       CALL message( 'check_parameters', 'PA0416', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
 !-- Check &userpar parameters
     CALL user_check_parameters
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1686)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of Obukhov length (ol) and radiative heating rates  for RRTMG. 
+! Formatting corrections.
 ! 
 ! Former revisions:
@@ -112,5 +113,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, nr, p, pt, q, qc, ql, ql_c, ql_v, ql_vp, qr, qsws,      &
+        ONLY:  dzw, e, nr, ol, p, pt, q, qc, ql, ql_c, ql_v, ql_vp, qr, qsws,  &
                rho, sa, shf, tend, ts, u, us, v, vpt, w, z0, z0h, zu, zw
         
@@ -162,6 +163,8 @@
     USE radiation_model_mod,                                                   &
         ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av, rad_sw_out,       &
-               rad_sw_out_av, rad_lw_in, rad_lw_in_av, rad_lw_out,             &
-               rad_lw_out_av 
+               rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,        &
+               rad_sw_hr_av, rad_lw_in, rad_lw_in_av, rad_lw_out,              &
+               rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,        &
+               rad_lw_hr_av
 
     IMPLICIT NONE
@@ -543,4 +546,22 @@
                 IF ( mode == 'xy' )  level_z = zu
 
+             CASE ( 'ol*_xy' )        ! 2d-array
+                IF ( av == 0 ) THEN
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = ol(j,i)
+                      ENDDO
+                   ENDDO
+                ELSE
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = ol_av(j,i)
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+                two_d = .TRUE.
+                level_z(nzb+1) = zu(nzb+1)
+
              CASE ( 'p_xy', 'p_xz', 'p_yz' )
                 IF ( av == 0 )  THEN
@@ -937,4 +958,18 @@
                 ENDIF
 
+             CASE ( 'rad_lw_cs_hr_xy', 'rad_lw_cs_hr_xz', 'rad_lw_cs_hr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_lw_cs_hr
+                ELSE
+                   to_be_resorted => rad_lw_cs_hr_av
+                ENDIF
+
+             CASE ( 'rad_lw_hr_xy', 'rad_lw_hr_xz', 'rad_lw_hr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_lw_hr
+                ELSE
+                   to_be_resorted => rad_lw_hr_av
+                ENDIF
+
              CASE ( 'rad_sw_in_xy', 'rad_sw_in_xz', 'rad_sw_in_yz' )
                 IF ( av == 0 )  THEN
@@ -949,4 +984,18 @@
                 ELSE
                    to_be_resorted => rad_sw_out_av
+                ENDIF
+
+             CASE ( 'rad_sw_cs_hr_xy', 'rad_sw_cs_hr_xz', 'rad_sw_cs_hr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_sw_cs_hr
+                ELSE
+                   to_be_resorted => rad_sw_cs_hr_av
+                ENDIF
+
+             CASE ( 'rad_sw_hr_xy', 'rad_sw_hr_xz', 'rad_sw_hr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => rad_sw_hr
+                ELSE
+                   to_be_resorted => rad_sw_hr_av
                 ENDIF
 
@@ -1227,5 +1276,5 @@
 !--                Exit the loop for layers beyond the data output domain
 !--                (used for soil model)
-                   IF ( layer_xy .GT. nzt_do )  THEN 
+                   IF ( layer_xy > nzt_do )  THEN 
                       EXIT loop1
                    ENDIF
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1686)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Added output of radiative heating rates for RRTMG
 ! 
 ! Former revisions:
@@ -138,5 +138,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
-               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
+               rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av,         &
+               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av,             &
+               rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av
 
 
@@ -495,4 +497,18 @@
              ENDIF
 
+          CASE ( 'rad_sw_cs_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_cs_hr
+             ELSE
+                to_be_resorted => rad_sw_cs_hr_av
+             ENDIF
+
+          CASE ( 'rad_sw_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_hr
+             ELSE
+                to_be_resorted => rad_sw_hr_av
+             ENDIF
+
           CASE ( 'rad_lw_in' )
              IF ( av == 0 )  THEN
@@ -507,4 +523,18 @@
              ELSE
                 to_be_resorted => rad_lw_out_av
+             ENDIF
+
+          CASE ( 'rad_lw_cs_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_cs_hr
+             ELSE
+                to_be_resorted => rad_lw_cs_hr_av
+             ENDIF
+
+          CASE ( 'rad_lw_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_hr
+             ELSE
+                to_be_resorted => rad_lw_hr_av
              ENDIF
 
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 1686)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of radiative heating rates for RRTMG
 ! 
 ! Former revisions:
@@ -119,5 +119,8 @@
     USE radiation_model_mod,                                                   &
         ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
-               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av
+               rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av,         &
+               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av,             &
+               rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av
+
 
     IMPLICIT NONE
@@ -405,4 +408,32 @@
              ENDIF
 
+          CASE ( 'rad_lw_in' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_in
+             ELSE
+                to_be_resorted => rad_lw_in_av
+             ENDIF
+
+          CASE ( 'rad_lw_out' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_out
+             ELSE
+                to_be_resorted => rad_lw_out_av
+             ENDIF
+
+          CASE ( 'rad_lw_cs_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_cs_hr
+             ELSE
+                to_be_resorted => rad_lw_cs_hr_av
+             ENDIF
+
+          CASE ( 'rad_lw_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_lw_hr
+             ELSE
+                to_be_resorted => rad_lw_hr_av
+             ENDIF
+
           CASE ( 'rad_sw_in' )
              IF ( av == 0 )  THEN
@@ -419,16 +450,16 @@
              ENDIF
 
-          CASE ( 'rad_lw_in' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_in
-             ELSE
-                to_be_resorted => rad_lw_in_av
-             ENDIF
-
-          CASE ( 'rad_lw_out' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_out
-             ELSE
-                to_be_resorted => rad_lw_out_av
+          CASE ( 'rad_sw_cs_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_cs_hr
+             ELSE
+                to_be_resorted => rad_sw_cs_hr_av
+             ENDIF
+
+          CASE ( 'rad_sw_hr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rad_sw_hr
+             ELSE
+                to_be_resorted => rad_sw_hr_av
              ENDIF
 
Index: palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_s.f90	(revision 1686)
+++ palm/trunk/SOURCE/diffusion_s.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Formatting corrections.
 ! 
 ! Former revisions:
@@ -144,6 +144,6 @@
 !
 !--          Apply prescribed horizontal wall heatflux where necessary
-             IF ( ( wall_w_x(j,i) .NE. 0.0_wp ) .OR. ( wall_w_y(j,i) .NE. 0.0_wp ) ) &
-             THEN
+             IF ( ( wall_w_x(j,i) /= 0.0_wp ) .OR. ( wall_w_y(j,i) /= 0.0_wp ) &
+                )  THEN
                 DO  k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
 
@@ -400,5 +400,5 @@
 !
 !--    Apply prescribed horizontal wall heatflux where necessary
-       IF ( ( wall_w_x(j,i) .NE. 0.0_wp ) .OR. ( wall_w_y(j,i) .NE. 0.0_wp ) )       &
+       IF ( ( wall_w_x(j,i) /= 0.0_wp ) .OR. ( wall_w_y(j,i) /= 0.0_wp ) )     &
        THEN
           DO  k = nzb_s_inner(j,i)+1, nzb_s_outer(j,i)
Index: palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_u.f90	(revision 1686)
+++ palm/trunk/SOURCE/diffusion_u.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Formatting corrections.
 ! 
 ! Former revisions:
@@ -508,5 +508,5 @@
 !
 !--    Wall functions at the north and south walls, respectively
-       IF ( wall_u(j,i) .NE. 0.0_wp )  THEN
+       IF ( wall_u(j,i) /= 0.0_wp )  THEN
 
 !
